-- rolling the roulette
kartzshields.RouletteTics = 3*TICRATE

kartzshields.StartPlayerRoulette = function(p)
	if (p.kzs.roulette or p.kzs.shield) then return end	-- nope, don't stack these
	p.kzs.roulette = 1
end
if (kartzshields.debug)
	COM_AddCommand("startshieldroulette", function(p, node)
		node = tonumber($)
		local tp = players[node]
		if not (tp and tp.valid) then return end
		
		tp.kzs.roulette = nil
		tp.kzs.shield = 0
		kartzshields.StartPlayerRoulette(tp)
	end, COM_ADMIN)
end

kartzshields.LapRoulette = function(p)
	-- the automated rolling process
	local mo = p.mo
	if not (mo and mo.valid) then return end	-- paranoia
	
	if (mo.kzs_lastlapcount != nil)	-- we need a last lap count saved
	and (mo.kzs_lastlapcount != p.laps)	-- new lap?
	and not (p.exiting)	-- haven't finished
		-- reset our shield and reroll!
		p.kzs.roulette = nil
		kartzshields.RemoveShield(p)
		kartzshields.StartPlayerRoulette(p)
	end
	mo.kzs_lastlapcount = p.laps
end

kartzshields.Roulette = function(p)
	if (p.kzs.shieldblink)
		p.kzs.shieldblink = $-1
	end
	if not (p.kzs.roulette) then return end
	
	-- roulette sound handling
	local roulette = p.kzs.roulette
	if not ((roulette - 1) % 3)
		local sound = sfx_shrol1 + ((roulette - 1) % 24/3)
		S_StartSound(nil, sound, p)
	end
	
	local roulettestop = TICRATE + (3*(kartzshields.GetPlayerCount() - p.kartstuff[k_position]))
	
	-- increase the roulette to eventually end it
	p.kzs.roulette = $+1
	if (p.kzs.roulette >= kartzshields.RouletteTics)	-- natural end
	or (p.kzs.roulette >= roulettestop and p.kzs_shieldbutton)	-- mash
		local mashed = 0
		if (p.kzs.roulette >= roulettestop and p.kzs_shieldbutton)
			mashed = FixedDiv((p.kzs.roulette)*FRACUNIT, ((TICRATE*3)+roulettestop)*FRACUNIT) - FRACUNIT
			p.kzs_shieldbutton = max(2, $)	-- little hack to prevent instant shield activation
		end
		p.kzs.roulette = nil
		
		-- time to get the shield!
		local shield = kartzshields.RollShieldOdds(p, mashed)
		if (shield)
			kartzshields.GiveShield(p, shield)	-- give them the shield
			
			-- roulette stop sound
			local sound = (mashed) and sfx_itrolm or sfx_itrolf
			p.kzs.shieldblink = TICRATE
			p.kzs.shieldblinkmode = (mashed) and 2 or 1	-- 1: normal, 2: mashed, 3: karma (unimplemented)
			S_StartSound(nil, sound, p)
		end
	end
end